"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.hijackLoaders = exports.pitch = void 0;
const path = __importStar(require("path"));
const constants_1 = require("./constants");
const find_up_1 = __importDefault(require("find-up"));
const fs_extra_1 = __importDefault(require("fs-extra"));
function getLoaderName(loaderPath) {
    const packageJsonPath = find_up_1.default.sync('package.json', { cwd: path.dirname(loaderPath) });
    if (packageJsonPath) {
        const pkg = fs_extra_1.default.readJSONSync(packageJsonPath);
        return pkg.name;
    }
    return '';
}
// Ref: https://github.com/stephencookdev/speed-measure-webpack-plugin/blob/v1.5.0/loader.js
function pitch() {
    // @ts-expect-error this type
    const callback = this[constants_1.PLUGIN_NAME];
    // TODO: filter inspect-webpack-plugin/loader
    // @ts-expect-error this type
    const loaderPaths = this.loaders.map((loader) => loader.path);
    hijackLoaders(loaderPaths, (loader, path) => {
        const loaderName = getLoaderName(path);
        const wrapFunc = (func) => async function (...args) {
            const start = Date.now();
            // @ts-expect-error this type
            const almostThis = Object.assign({}, this, {
                async: function (...asyncArgs) {
                    // @ts-expect-error this type
                    const asyncCallback = this.async.apply(this, asyncArgs);
                    // @ts-expect-error this type
                    const { resource } = this;
                    return function (...args) {
                        const end = Date.now();
                        const [, source] = args;
                        callback({
                            id: resource,
                            name: loaderName,
                            result: source,
                            start,
                            end,
                        });
                        // @ts-expect-error this type
                        return asyncCallback.apply(this, args);
                    };
                    // @ts-expect-error this type
                }.bind(this),
            });
            const ret = func.apply(almostThis, args);
            return ret;
        };
        if (loader.normal)
            loader.normal = wrapFunc(loader.normal);
        if (loader.default)
            loader.default = wrapFunc(loader.default);
        if (loader.pitch)
            loader.pitch = wrapFunc(loader.pitch);
        if (typeof loader === 'function')
            return wrapFunc(loader);
        return loader;
    });
}
exports.pitch = pitch;
function hijackLoaders(loaderPaths, callback) {
    const wrapReq = (reqMethod) => {
        return function (...args) {
            // @ts-expect-error this type
            const ret = reqMethod.apply(this, args);
            if (loaderPaths.includes(args[0])) {
                return callback(ret, args[0]);
            }
            return ret;
        };
    };
    const Module = require('module');
    Module.prototype.require = wrapReq(Module.prototype.require);
}
exports.hijackLoaders = hijackLoaders;
//# sourceMappingURL=loader.js.map